## qtpdwidgets2 2.0.0.2.g61d1554

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
# Copyright (C) 2022 Bjarne von Horn <vh@igh.de>
#
# This file is part of the QtPdWidgets library.
#
# The QtPdWidgets library is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# The QtPdWidgets library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with the QtPdWidgets Library. If not, see
# <http://www.gnu.org/licenses/>.
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.10)

project(QtPdWidgets2 VERSION 2.0.0)

include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

# Configure build

option(DESIGNER_PLUGIN "Build as Qt Designer plugin" ON)
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(BUILD_EXAMPLE "Also build example" OFF)

# Load required packages

set(REQUIRED_PUBLIC_QT_MODULES Gui Widgets)
set(REQUIRED_QT_MODULES ${REQUIRED_PUBLIC_QT_MODULES} LinguistTools Svg Xml)
if(DESIGNER_PLUGIN)
    list(APPEND REQUIRED_QT_MODULES Designer)
endif()

find_package(QtPdCom1 REQUIRED)
find_package(Qt5 REQUIRED
    COMPONENTS ${REQUIRED_QT_MODULES}
)

# handle translation files

set(TS_FILES
    QtPdWidgets_de.ts
    QtPdWidgets_nl.ts
)

configure_file(QtPdWidgets_ts.qrc "${CMAKE_CURRENT_BINARY_DIR}" COPYONLY)
qt5_add_translation(QM_FILES ${TS_FILES})

# add source files and headers

set(PUBLIC_HEADERS
    ${PROJECT_NAME}/Translator.h
    ${PROJECT_NAME}/ValueRing.h
    ${PROJECT_NAME}/Widget.h
    ${PROJECT_NAME}/Bar.h
    ${PROJECT_NAME}/CheckBox.h
    ${PROJECT_NAME}/ClipImage.h
    ${PROJECT_NAME}/CursorEditWidget.h
    ${PROJECT_NAME}/Dial.h
    ${PROJECT_NAME}/Digital.h
    ${PROJECT_NAME}/DoubleSpinBox.h
    ${PROJECT_NAME}/Export.h
    ${PROJECT_NAME}/Graph.h
    ${PROJECT_NAME}/Image.h
    ${PROJECT_NAME}/Led.h
    ${PROJECT_NAME}/MultiLed.h
    ${PROJECT_NAME}/NoPdTouchEdit.h
    ${PROJECT_NAME}/ParameterSetWidget.h
    ${PROJECT_NAME}/PushButton.h
    ${PROJECT_NAME}/RadioButton.h
    ${PROJECT_NAME}/Rotor.h
    ${PROJECT_NAME}/Scale.h
    ${PROJECT_NAME}/SendBroadcastWidget.h
    ${PROJECT_NAME}/Settings.h
    ${PROJECT_NAME}/SpinBox.h
    ${PROJECT_NAME}/Svg.h
    ${PROJECT_NAME}/TableView.h
    ${PROJECT_NAME}/Tank.h
    ${PROJECT_NAME}/Text.h
    ${PROJECT_NAME}/Time.h
    ${PROJECT_NAME}/TimeScale.h
    ${PROJECT_NAME}/TouchEdit.h
    ${PROJECT_NAME}/TouchEditDialog.h
    ${PROJECT_NAME}/XYGraph.h
)

set(SOURCES
    src/Bar.cpp
    src/BarSection.cpp
    src/BarSection.h
    src/BarStack.cpp
    src/BarStack.h
    src/CheckBox.cpp
    src/ClipImage.cpp
    src/CursorEditWidget.cpp
    src/Dial.cpp
    src/Digital.cpp
    src/DoubleSpinBox.cpp
    src/Graph.cpp
    src/Image.cpp
    src/Led.cpp
    src/MultiLed.cpp
    src/NoPdTouchEdit.cpp
    src/Parameter.cpp
    src/Parameter.h
    src/ParameterSetWidget.cpp
    src/PushButton.cpp
    src/RadioButton.cpp
    src/Rotor.cpp
    src/Scale.cpp
    src/SendBroadcastWidget.cpp
    src/Settings.cpp
    src/SpinBox.cpp
    src/Svg.cpp
    src/TableView.cpp
    src/Tank.cpp
    src/Text.cpp
    src/Time.cpp
    src/TimeScale.cpp
    src/TouchEdit.cpp
    src/TouchEditDialog.cpp
    src/Translator.cpp
    src/Version.cpp
    src/Widget.cpp
    src/XYGraph.cpp
)

if (DESIGNER_PLUGIN)
    list(APPEND SOURCES
        src/Plugin.h
        src/WidgetCollection.h
        src/Plugin.cpp
        src/WidgetCollection.cpp
    )
endif()

configure_file(QtPdWidgets2.h.in "${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets2.h")

add_library(${PROJECT_NAME}
    ${PUBLIC_HEADERS}
    ${SOURCES}

    ${QM_FILES}
    QtPdWidgets.qrc
    ${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets_ts.qrc
)

# bake in git revision

if (VERSION_HASH)
    # Hash was given as option, so write it directly
    # useful for OBS packaging
    file (WRITE "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        "#define GIT_REV \"${VERSION_HASH}\"
")
else()
    # recompute hash on every `make` invocation
    # Note: CMake variable definitions (-D) must be before the -P option!
    add_custom_target (GitRevision
        BYPRODUCTS "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        COMMAND ${CMAKE_COMMAND}
            -DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}"
            -DHASH_MACRO_NAME="GIT_REV"
            -DTARGET_FILE="${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
            -P ${CMAKE_CURRENT_SOURCE_DIR}/git_revision.cmake
    )
    add_dependencies(${PROJECT_NAME} GitRevision)
endif()

# set include path

target_include_directories(${PROJECT_NAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:include>"
)

# link to required and optional libraries

target_link_libraries(${PROJECT_NAME}
PUBLIC
    EtherLab::QtPdCom1
    Qt5::Core
    Qt5::Gui
    Qt5::Widgets
PRIVATE
    Qt5::Svg
    Qt5::Xml
)

if(DESIGNER_PLUGIN)
    # note: library is not installed into designer plugin directory on its own!
    target_link_libraries(${PROJECT_NAME} PRIVATE Qt5::Designer)
    target_compile_definitions(${PROJECT_NAME}
        PRIVATE "QDESIGNER_EXPORT_WIDGETS" "PD_QT5" "PD_IS_DESIGNER_PLUGIN"
    )
endif()

if(WIN32)
    # for gethostname in Process.cpp
    target_link_libraries(${PROJECT_NAME} PRIVATE -lwsock32)
endif()

# enable resource compiler etc.

set_target_properties(${PROJECT_NAME} PROPERTIES
    AUTOUIC ON
    AUTOMOC ON
    AUTORCC ON
    PUBLIC_HEADER "${PUBLIC_HEADERS}"
    CXX_VISIBILITY_PRESET "hidden"
    VISIBILITY_INLINES_HIDDEN 1
    VERSION ${PROJECT_VERSION}
    SOVERSION 2
)

target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_11)

# install library and headers

install(TARGETS ${PROJECT_NAME}
    EXPORT ${PROJECT_NAME}Targets
    ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION       "${CMAKE_INSTALL_BINDIR}"
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}"
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets2.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

if (DESIGNER_PLUGIN)
    # Call qmake to query the plugin installation directory.
    get_target_property(QT_QMAKE_EXECUTABLE Qt5::qmake LOCATION)
    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
        OUTPUT_VARIABLE QT_INSTALL_PLUGINS OUTPUT_STRIP_TRAILING_WHITESPACE
    )

    # Install the library in QtDesigner plugin directory
    install(TARGETS ${PROJECT_NAME}
        LIBRARY DESTINATION ${QT_INSTALL_PLUGINS}/designer
        RUNTIME DESTINATION ${QT_INSTALL_PLUGINS}/designer
    )
endif()

# export target for use in other projects

set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}")
configure_package_config_file(Config.cmake.in
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake"
    INSTALL_DESTINATION ${ConfigPackageLocation}
)
write_basic_package_version_file(
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
)

install(EXPORT ${PROJECT_NAME}Targets
    NAMESPACE EtherLab::
    FILE "${PROJECT_NAME}Targets.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}ConfigVersion.cmake"
    DESTINATION ${ConfigPackageLocation}
)
export(EXPORT ${PROJECT_NAME}Targets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}/${PROJECT_NAME}Targets.cmake"
    NAMESPACE EtherLab::
)

if(BUILD_EXAMPLE)
    add_library(EtherLab::${PROJECT_NAME} ALIAS ${PROJECT_NAME})
    add_subdirectory(example)
endif()

configure_file(Doxyfile.in "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile" @ONLY)

=== example/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
# Copyright (C) 2022 Bjarne von Horn <vh@igh.de>
#
# This file is part of the QtPdWidgets library.
#
# The QtPdWidgets library is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# The QtPdWidgets library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with the QtPdWidgets Library. If not, see
# <http://www.gnu.org/licenses/>.
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.10)

project(pdwidgetsexample)

# load Qt
find_package(Qt5 REQUIRED COMPONENTS Gui Network Quick Svg Widgets Xml)
# load PdWidgets
if (NOT TARGET EtherLab::QtPdWidgets2)
    find_package(QtPdWidgets2 REQUIRED)
endif()

add_executable(${PROJECT_NAME}
    MainWindow.ui
    MainWindow.h
    MainWindow.cpp
    main.cpp

    example.qrc
)

# enable moc, uic and rcc
set_target_properties(${PROJECT_NAME} PROPERTIES
    AUTOUIC 1
    AUTOMOC 1
    AUTORCC 1
)
target_compile_features(${PROJECT_NAME} PUBLIC cxx_std_14)

# link against Qt and PdWidgets
target_link_libraries(${PROJECT_NAME} PUBLIC
    EtherLab::QtPdWidgets2
    Qt5::Gui
    Qt5::Widgets
)

=== debian/changelog ===
qtpdwidgets2 (2.0.0.2.g61d1554-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100

=== debian/control ===
Source: qtpdwidgets2
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: dh-exec (>= 0.3), debhelper (>= 9), qtchooser, qtbase5-dev, libqt5svg5-dev, qttools5-dev, qttools5-dev-tools, libqtpdcom1-dev, cmake (>= 3.10)
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.etherlab.org

Package: libqtpdwidgets2-dev
Section: libdevel
Architecture: any
Depends: libqtpdwidgets2 (= ${binary:Version}), libqtpdcom1-dev, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 Header files

Package: libqtpdwidgets2
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.

Package: libqtpdwidgets2-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libqtpdwidgets2 (= ${binary:Version}), ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt5. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 This package contains the debugging symbols for libpqtpdwidgets

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt5

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

QTPDWIDGETS_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}"

%:
	dh $@ --parallel

.PHONY:
	override_dh_strip

override_dh_install:
	dh_install
	# workaround for Ubuntu 20.04 where headers are installed twice
	rm debian/tmp/usr/include/*.h || true

override_dh_strip:
	dh_strip --dbg-package=libqtpdwidgets2-dbg

override_dh_missing:
	dh_missing --fail-missing

override_dh_shlibdeps:
	dh_shlibdeps -l $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

## qtpdwidgets2 2.3.2.g888405b

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
# Copyright (C) 2022 Bjarne von Horn <vh@igh.de>
#
# This file is part of the QtPdWidgets library.
#
# The QtPdWidgets library is free software: you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public License as
# published by the Free Software Foundation, either version 3 of the License,
# or (at your option) any later version.
#
# The QtPdWidgets library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser
# General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with the QtPdWidgets Library. If not, see
# <http://www.gnu.org/licenses/>.
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 3.10)

project(QtPdWidgets2 VERSION 2.3.2) # Do not forget to update NEWS

set(SOVERSION 3)

include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

# Configure build

option(DESIGNER_PLUGIN "Build as Qt Designer plugin" ON)
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)
option(BUILD_EXAMPLE "Also build example" OFF)
option(USE_SYMBOL_VERSIONING "Use ELF symbol versioning" OFF)
option(USE_QT6 "Use Qt6 instead of Qt5" OFF)
option(PUT_QT_MAJOR_INTO_LIBNAME "Put Qt Major Version into Library Name" OFF)
cmake_dependent_option(
    CHECK_SYMBOL_VERSIONING
    "Verify symbol versioning after build"
    ON
    "USE_SYMBOL_VERSIONING"
    OFF
)

# Load required packages

set(REQUIRED_PUBLIC_QT_MODULES Gui Widgets)
set(REQUIRED_QT_MODULES ${REQUIRED_PUBLIC_QT_MODULES} LinguistTools Svg Xml Network)
if(DESIGNER_PLUGIN)
    list(APPEND REQUIRED_QT_MODULES Designer)
endif()
if(USE_QT6)
    set(Qt Qt6)
    list(APPEND REQUIRED_QT_MODULES Core5Compat)
else()
    set(Qt Qt5)
endif()

if (PUT_QT_MAJOR_INTO_LIBNAME)
    set(LIBNAME "${Qt}PdWidgets2")
    set(QtPdCom "${Qt}PdCom1")
else()
    set(LIBNAME "${PROJECT_NAME}")
    set(QtPdCom "QtPdCom1")
endif()
find_package(${Qt} REQUIRED
    COMPONENTS ${REQUIRED_QT_MODULES}
)
find_package(${QtPdCom} REQUIRED)

if (USE_SYMBOL_VERSIONING)
    find_package(PythonInterp 3 REQUIRED)
endif()

# handle translation files

set(TS_FILES
    QtPdWidgets_de.ts
    QtPdWidgets_nl.ts
)

configure_file(QtPdWidgets_ts.qrc "${CMAKE_CURRENT_BINARY_DIR}" COPYONLY)

if(USE_QT6)
    qt6_add_resources(QRC_SOURCES
        QtPdWidgets.qrc
        ${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets_ts.qrc
    )

    qt6_add_translation(QM_FILES ${TS_FILES})
else()
    qt5_add_resources(QRC_SOURCES
        QtPdWidgets.qrc
        ${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets_ts.qrc
    )

    qt5_add_translation(QM_FILES ${TS_FILES})
endif()

# add source files and headers

set(PUBLIC_HEADERS
    ${PROJECT_NAME}/Translator.h
    ${PROJECT_NAME}/Bar.h
    ${PROJECT_NAME}/CheckBox.h
    ${PROJECT_NAME}/ClipImage.h
    ${PROJECT_NAME}/CursorEditWidget.h
    ${PROJECT_NAME}/Dial.h
    ${PROJECT_NAME}/Digital.h
    ${PROJECT_NAME}/DoubleSpinBox.h
    ${PROJECT_NAME}/Export.h
    ${PROJECT_NAME}/Graph.h
    ${PROJECT_NAME}/Image.h
    ${PROJECT_NAME}/Led.h
    ${PROJECT_NAME}/MultiLed.h
    ${PROJECT_NAME}/NoPdTouchEdit.h
    ${PROJECT_NAME}/ParameterSetWidget.h
    ${PROJECT_NAME}/PushButton.h
    ${PROJECT_NAME}/RadioButton.h
    ${PROJECT_NAME}/Rotor.h
    ${PROJECT_NAME}/SendBroadcastWidget.h
    ${PROJECT_NAME}/SpinBox.h
    ${PROJECT_NAME}/Svg.h
    ${PROJECT_NAME}/TableView.h
    ${PROJECT_NAME}/Tank.h
    ${PROJECT_NAME}/Text.h
    ${PROJECT_NAME}/Time.h
    ${PROJECT_NAME}/TouchEdit.h
    ${PROJECT_NAME}/TouchEditDialog.h
    ${PROJECT_NAME}/XYGraph.h
)

set(SOURCES
    src/Bar.cpp
    src/Bar_p.h
    src/BarSection.cpp
    src/BarSection.h
    src/BarStack.cpp
    src/BarStack.h
    src/CheckBox.cpp
    src/ClipImage.cpp
    src/CursorEditWidget.cpp
    src/Dial.cpp
    src/Digital.cpp
    src/DoubleSpinBox.cpp
    src/Graph.cpp
    src/Image.cpp
    src/Led.cpp
    src/MultiLed.cpp
    src/NoPdTouchEdit.cpp
    src/Parameter.cpp
    src/Parameter.h
    src/ParameterFileSystemModel.cpp
    src/ParameterFileSystemModel.h
    src/ParameterSetWidget.cpp
    src/PushButton.cpp
    src/RadioButton.cpp
    src/Rotor.cpp
    src/Scale.cpp
    src/Scale.h
    src/SendBroadcastWidget.cpp
    src/SpinBox.cpp
    src/Svg.cpp
    src/TableView.cpp
    src/TableViewImpl.h
    src/Tank.cpp
    src/Text.cpp
    src/Time.cpp
    src/TimeScale.cpp
    src/TimeScale.h
    src/TouchEdit.cpp
    src/TouchEditDialog.cpp
    src/Translator.cpp
    src/ValueRing.h
    src/Version.cpp
    src/Widget.h
    src/Widget.cpp
    src/XYGraph.cpp
)

if (DESIGNER_PLUGIN)
    add_library(${LIBNAME}Plugin
        src/Plugin.h
        src/WidgetCollection.h
        src/Plugin.cpp
        src/WidgetCollection.cpp
    )
endif()

configure_file(QtPdWidgets2.h.in "${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets2.h")

add_library(${LIBNAME}
    ${PUBLIC_HEADERS}
    ${SOURCES}

    ${QM_FILES}
    ${QRC_SOURCES}
)

# bake in git revision

if (VERSION_HASH)
    # Hash was given as option, so write it directly
    # useful for OBS packaging
    file (WRITE "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        "#define GIT_REV \"${VERSION_HASH}\"
")
else()
    # recompute hash on every `make` invocation
    # Note: CMake variable definitions (-D) must be before the -P option!
    add_custom_target (GitRevision
        BYPRODUCTS "${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
        COMMAND ${CMAKE_COMMAND}
            -DSOURCE_DIR="${CMAKE_CURRENT_SOURCE_DIR}"
            -DHASH_MACRO_NAME="GIT_REV"
            -DTARGET_FILE="${CMAKE_CURRENT_BINARY_DIR}/git_revision_hash.h"
            -P ${CMAKE_CURRENT_SOURCE_DIR}/git_revision.cmake
    )
    add_dependencies(${LIBNAME} GitRevision)
endif()

if (USE_SYMBOL_VERSIONING)
    if (NOT SYMBOL_VERSIONING_ARCH)
        if ("${CMAKE_SIZEOF_VOID_P}" EQUAL 8)
            set(SYMBOL_VERSIONING_ARCH "generic64")
        elseif("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "^arm")
            set(SYMBOL_VERSIONING_ARCH "arm")
        else()
            set(SYMBOL_VERSIONING_ARCH "x86")
        endif()
        message(STATUS "Using Symbol Versioning arch ${SYMBOL_VERSIONING_ARCH}")
    endif()
    add_custom_command(OUTPUT QtPdWidgets.map
        COMMAND "${PYTHON_EXECUTABLE}"
        ARGS "${CMAKE_CURRENT_SOURCE_DIR}/symbol-versioning/symbol_version_tool.py"
                -i "${CMAKE_CURRENT_SOURCE_DIR}/${Qt}PdWidgets.map.yaml"
                -o "${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets.map"
                --arch "${SYMBOL_VERSIONING_ARCH}"
                GenerateLinkerVersionScript
        MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/${Qt}PdWidgets.map.yaml"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/symbol-versioning/symbol_version_tool.py"
    )
    # to force relinking upon changing the map file,
    # we add an OBJECT_DEPENDS
    set(WIDGET_DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets.map")
    set_source_files_properties(src/Widget.cpp PROPERTIES
        OBJECT_DEPENDS "${WIDGET_DEPENDS}"
    )
    # inform linker about version script
    set_target_properties(${LIBNAME} PROPERTIES
        LINK_FLAGS " -Wl,-version-script=${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets.map"
    )

    if (CHECK_SYMBOL_VERSIONING)
        add_custom_target(CheckVersionScript ALL
            "${PYTHON_EXECUTABLE}"
            "${CMAKE_CURRENT_SOURCE_DIR}/symbol-versioning/symbol_version_tool.py"
            -i "${CMAKE_CURRENT_SOURCE_DIR}/${Qt}PdWidgets.map.yaml"
            --arch "${SYMBOL_VERSIONING_ARCH}"
            --library $<TARGET_FILE:${LIBNAME}>
            CheckGeneratedLibraries
            COMMENT "Checking whether all symbols are versioned correctly..."
        )
    endif()
endif()

# set include path

target_include_directories(${LIBNAME} PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/${PROJECT_NAME}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>"
    "$<INSTALL_INTERFACE:include>"
)

# link to required and optional libraries

target_link_libraries(${LIBNAME}
PUBLIC
    EtherLab::${QtPdCom}
    ${Qt}::Core
    ${Qt}::Gui
    ${Qt}::Widgets
PRIVATE
    ${Qt}::Svg
    ${Qt}::Xml
)

if(USE_QT6)
    target_link_libraries(${LIBNAME} PRIVATE Qt6::Core5Compat)
endif()

if (PUT_QT_MAJOR_INTO_LIBNAME)
    # Export.h needs _EXPORTS macro without Qt Major version
    # to expand PD_PUBLIC
    target_compile_definitions(${LIBNAME} PRIVATE
        "${PROJECT_NAME}_EXPORTS"
    )
endif()


if(DESIGNER_PLUGIN)
    target_link_libraries(${LIBNAME}Plugin PRIVATE ${Qt}::Designer ${LIBNAME})
    set_target_properties(${LIBNAME}Plugin PROPERTIES
        AUTOMOC ON
    )
endif()

if(WIN32)
    # for gethostname in Process.cpp
    target_link_libraries(${LIBNAME} PRIVATE -lwsock32)
endif()

# enable resource compiler etc.

set_target_properties(${LIBNAME} PROPERTIES
    AUTOUIC ON
    AUTOMOC ON
    AUTORCC ON
    PUBLIC_HEADER "${PUBLIC_HEADERS}"
    CXX_VISIBILITY_PRESET "hidden"
    VISIBILITY_INLINES_HIDDEN 1
    VERSION "${SOVERSION}.${PROJECT_VERSION_MINOR}.${PROJECT_VERSION_PATCH}"
    SOVERSION ${SOVERSION}
)

target_compile_features(${LIBNAME} PUBLIC cxx_std_11)

# install library and headers

install(TARGETS ${LIBNAME}
    EXPORT ${LIBNAME}Targets
    ARCHIVE DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION       "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION       "${CMAKE_INSTALL_BINDIR}"
    PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME}"
)

install(FILES "${CMAKE_CURRENT_BINARY_DIR}/QtPdWidgets2.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

if (DESIGNER_PLUGIN)
    # Call qmake to query the plugin installation directory.
    get_target_property(QT_QMAKE_EXECUTABLE ${Qt}::qmake LOCATION)
    execute_process(COMMAND ${QT_QMAKE_EXECUTABLE} -query QT_INSTALL_PLUGINS
        OUTPUT_VARIABLE QT_INSTALL_PLUGINS OUTPUT_STRIP_TRAILING_WHITESPACE
    )

    # Install the library in QtDesigner plugin directory
    install(TARGETS ${LIBNAME}Plugin
        LIBRARY DESTINATION ${QT_INSTALL_PLUGINS}/designer
        RUNTIME DESTINATION ${QT_INSTALL_PLUGINS}/designer
    )
endif()

# export target for use in other projects

set(ConfigPackageLocation "${CMAKE_INSTALL_LIBDIR}/cmake/${LIBNAME}")
configure_package_config_file(Config.cmake.in
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}Config.cmake"
    INSTALL_DESTINATION ${ConfigPackageLocation}
)
write_basic_package_version_file(
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}ConfigVersion.cmake"
    COMPATIBILITY SameMajorVersion
)

install(EXPORT ${LIBNAME}Targets
    NAMESPACE EtherLab::
    FILE "${LIBNAME}Targets.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${LIBNAME}"
)
install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}Config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}ConfigVersion.cmake"
    DESTINATION ${ConfigPackageLocation}
)
export(EXPORT ${LIBNAME}Targets
    FILE "${CMAKE_CURRENT_BINARY_DIR}/${LIBNAME}/${LIBNAME}Targets.cmake"
    NAMESPACE EtherLab::
)

if(BUILD_EXAMPLE)
    add_library(EtherLab::${LIBNAME} ALIAS ${LIBNAME})
    add_subdirectory(example)
endif()

configure_file(Doxyfile.in "${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile" @ONLY)

# replacement for lupdate-pro
# just run `make lupdate` in your build dir after running cmake
add_custom_target(lupdate
    ${Qt}::lupdate -locations none -I${LIBNAME} ${SOURCES} ${PUBLIC_HEADERS} -ts ${TS_FILES}
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

=== debian/changelog ===
qtpdwidgets2 (2.3.2.g888405b-0+322.1) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Mon, 26 May 2025 14:20:47 +0000

qtpdwidgets2 (2.3.2.g888405b-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100

## qtpdwidgets2 2.3.3.g18681dc

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 cmake_minimum_required(VERSION 3.10)
 
-project(QtPdWidgets2 VERSION 2.3.2) # Do not forget to update NEWS
+project(QtPdWidgets2 VERSION 2.3.3) # Do not forget to update NEWS
 
 set(SOVERSION 3)

=== debian/changelog ===
qtpdwidgets2 (2.3.3.g18681dc-0+324.5) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Sun, 20 Jul 2025 05:41:37 +0000

qtpdwidgets2 (2.3.3.g18681dc-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100

=== debian/control ===
Source: qtpdwidgets2
Priority: optional
Maintainer: Andreas Stewering-Bone <ab@igh.de>
Build-Depends: dh-exec (>= 0.3), debhelper (>= 9), qtchooser, qt6-5compat-dev, qt6-base-dev, qt6-svg-dev, qt6-tools-dev, qt6-tools-dev-tools, libqt6pdcom1-dev, cmake (>= 3.10), python3, python3-yaml, libqt6opengl6-dev
Standards-Version: 3.9.5
Section: libs
Homepage: http://www.etherlab.org

Package: libqt6pdwidgets2-dev
Section: libdevel
Architecture: any
Depends: libqtpdwidgets2-headers (= ${binary:Version}), libqt6pdwidgets2-3 (= ${binary:Version}), libqt6pdcom1-dev, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.
 .
 Header files

Package: libqt6pdwidgets2-3
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Process data widgets for Qt
 This is a bundle of process data widgets for Qt6. It uses the PdCom library to
 access the actual process variables and it includes a plugin for the Qt
 Designer. See http://etherlab.org/en/pdwidgets for more information.

=== debian/rules ===
#!/usr/bin/make -f

export QT_SELECT := qt6

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)


# be strict regarding symbol file
export DPKG_GENSYMBOLS_CHECK_LEVEL := 3

# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

QTPDWIDGETS_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`

override_dh_auto_configure:
	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}" -DUSE_SYMBOL_VERSIONING=1 -DUSE_QT6=1 -DPUT_QT_MAJOR_INTO_LIBNAME=1

%:
	dh $@ --parallel

.PHONY:
	override_dh_strip

override_dh_install:
	dh_install
	python3 symbol-versioning/symbol_version_tool.py -i Qt6PdWidgets.map.yaml --library $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQt6PdWidgets2.so.3 \
		-o debian/libqt6pdwidgets2-3.symbols GenerateDebianSymbolsFile

## qtpdwidgets2 2.3.4.gda637bb

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 
 cmake_minimum_required(VERSION 3.10)
 
-project(QtPdWidgets2 VERSION 2.3.3) # Do not forget to update NEWS
+project(QtPdWidgets2 VERSION 2.3.4) # Do not forget to update NEWS.md
 
 set(SOVERSION 3)

=== example/CMakeLists.txt ===
--- 
+++ 
@@ -24,11 +24,32 @@
 
 project(pdwidgetsexample)
 
+option(USE_QT6 "Use Qt6 instead of Qt5" OFF)
+option(PUT_QT_MAJOR_INTO_LIBNAME "Put Qt Major Version into Library Name" OFF)
+
+if(USE_QT6)
+    set(Qt Qt6)
+else()
+    set(Qt Qt5)
+endif()
+
+if (PUT_QT_MAJOR_INTO_LIBNAME)
+    set(Widgets "${Qt}PdWidgets2")
+else()
+    set(Widgets "QtPdWidgets2")
+endif()
+
 # load Qt
-find_package(Qt5 REQUIRED COMPONENTS Gui Network Quick Svg Widgets Xml)
+find_package(${Qt} REQUIRED COMPONENTS Gui Network Quick Svg Widgets Xml)
 # load PdWidgets
-if (NOT TARGET EtherLab::QtPdWidgets2)
-    find_package(QtPdWidgets2 REQUIRED)
+if (NOT TARGET EtherLab::${Widgets})
+    find_package(${Widgets} REQUIRED)
+endif()
+
+if (USE_QT6)
+    qt6_add_resources(EXAMPLE_QRC_SOURCES example.qrc)
+else()
+    qt5_add_resources(EXAMPLE_QRC_SOURCES example.qrc)
 endif()
 
 add_executable(${PROJECT_NAME}
@@ -37,7 +58,7 @@
     MainWindow.cpp
     main.cpp
 
-    example.qrc
+    ${EXAMPLE_QRC_SOURCES}
 )
 
 # enable moc, uic and rcc
@@ -50,7 +71,7 @@
 
 # link against Qt and PdWidgets
 target_link_libraries(${PROJECT_NAME} PUBLIC
-    EtherLab::QtPdWidgets2
-    Qt5::Gui
-    Qt5::Widgets
+    EtherLab::${Widgets}
+    ${Qt}::Gui
+    ${Qt}::Widgets
 )

=== debian/changelog ===
qtpdwidgets2 (2.3.4.gda637bb-0+327.1) UNRELEASED; urgency=medium

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Thu, 16 Oct 2025 16:27:54 +0000

qtpdwidgets2 (2.3.4.gda637bb-0) UNRELEASED; urgency=medium

   * Initial, First build

 -- Bjarne von Horn <vh@igh.de>  Mon, 24 Jan 2022 16:14:57 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export QT_SELECT := qt6
+export QT_SELECT := qt5
 
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 
@@ -28,7 +28,7 @@
 QTPDWIDGETS_VERSION=`dpkg-parsechangelog --show-field Version | cut -d - -f 1`
 
 override_dh_auto_configure:
-	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}" -DUSE_SYMBOL_VERSIONING=1 -DUSE_QT6=1 -DPUT_QT_MAJOR_INTO_LIBNAME=1
+	dh_auto_configure -- -DVERSION_HASH="${QTPDWIDGETS_VERSION}" -DUSE_SYMBOL_VERSIONING=1
 
 %:
 	dh $@ --parallel
@@ -38,5 +38,5 @@
 
 override_dh_install:
 	dh_install
-	python3 symbol-versioning/symbol_version_tool.py -i Qt6PdWidgets.map.yaml --library $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQt6PdWidgets2.so.3 \
-		-o debian/libqt6pdwidgets2-3.symbols GenerateDebianSymbolsFile
+	python3 symbol-versioning/symbol_version_tool.py -i Qt5PdWidgets.map.yaml --library $(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/libQtPdWidgets2.so.3 \
+		-o debian/libqtpdwidgets2-3.symbols GenerateDebianSymbolsFile
